package com.yc.ship.module.resource.service.roommodel;

import java.util.*;
import javax.validation.*;
import com.yc.ship.module.resource.controller.admin.roommodel.vo.*;
import com.yc.ship.module.resource.controller.app.roommodel.vo.AppResourceRoomModelPageReqVO;
import com.yc.ship.module.resource.dal.dataobject.roommodel.ResourceRoomModelDO;
import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.framework.common.pojo.PageParam;

/**
 * 资源管理-房型管理 Service 接口
 *
 * @author lfy
 */
public interface ResourceRoomModelService {

    /**
     * 创建资源管理-房型管理
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createRoomModel(@Valid ResourceRoomModelSaveReqVO createReqVO);

    /**
     * 更新资源管理-房型管理
     *
     * @param updateReqVO 更新信息
     */
    void updateRoomModel(@Valid ResourceRoomModelSaveReqVO updateReqVO);

    /**
     * 删除资源管理-房型管理
     *
     * @param id 编号
     */
    void deleteRoomModel(Long id);

    /**
     * 获得资源管理-房型管理
     *
     * @param id 编号
     * @return 资源管理-房型管理
     */
    ResourceRoomModelDO getRoomModel(Long id);

    /**
     * 获得资源管理-房型管理分页
     *
     * @param pageReqVO 分页查询
     * @return 资源管理-房型管理分页
     */
    PageResult<ResourceRoomModelDO> getRoomModelPage(ResourceRoomModelPageReqVO pageReqVO);

    /**
     * 根据游轮ID获取房型列表
     * @param shipId
     * @return
     */
    List<ResourceRoomModelDO> getRoomModelListByShipId(String shipId);

    List<ResourceRoomModelDO> getList(List<Long> modelIds);

    /**
     * 获取可以销售的房型列表
     * @param shipId
     * @return
     */
    List<ResourceRoomModelDO> getRoomModelCanSaleListByShipId(String shipId);

    PageResult<ResourceRoomModelDO> getAppRoomModelPage(AppResourceRoomModelPageReqVO pageReqVO);
}